<template>
  <ul v-if="!deleted">
    <li>
      <div :class="getWrapperClass(goal)">
        <span :class="getLabelClass()" class="font-bold italic">
          {{ goal.label }}:
        </span>
        <span :class="getNameClass()" class="block leading-none cursor-pointer" @click="setAsSelectedGoal">
          {{ goal.name }}
        </span>

        <template v-if="isSelectedGoal">
          <div class="mt-3">
            {{ goal.description }}
          </div>
          <div class="mt-3 flex justify-end">
            <button-remove class="mr-2" @click.native="deleteGoal" />
            <button-edit class="mr-2" :to="{name: 'goals-update-id', params: {id: goal.id}}" />
            <button-create v-if="level != 3" :to="{name: 'goals-create', query: {parent: goal.id}}" />
          </div>
        </template>
      </div>

      <ul
        v-for="child in goal.children"
        :key="child.id"
        class="ml-6"
      >
        <li>
          <goal :goal="child" />
        </li>
      </ul>
    </li>
  </ul>
</template>

<script>
import ButtonEdit from '~/components/buttons/Edit'
import ButtonCreate from '~/components/buttons/Create'
import ButtonRemove from '~/components/buttons/Remove'
import labelMixin from '~/mixins/labelMixin'
import GoalModal from '~/models/Goal'

export default {
  name: 'Goal',

  components: {
    ButtonEdit,
    ButtonCreate,
    ButtonRemove
  },

  mixins: [
    labelMixin
  ],

  props: {
    goal: {
      type: Object,
      default () {
        return new GoalModal()
      }
    }
  },

  data () {
    return {
      level: this.getLevel(this.goal.label),
      deleted: false
    }
  },

  computed: {
    isSelectedGoal () {
      return this.$store.getters['goals/getSelectedGoalId'] === this.goal.id
    }
  },

  methods: {
    getWrapperClass (item) {
      let cssClass = ''
      if (this.isSelectedGoal) {
        cssClass = cssClass + 'border-t border-b pt-4 pb-4'
      }
      switch (this.level) {
        case 0:
          cssClass += ' mt-8'
          break
        case 1:
          cssClass += ' mt-8'
          break
        case 2:
          cssClass += ' mt-6'
          break
        case 3:
          cssClass += ' mt-4'
          break
      }

      return cssClass
    },
    getLabelClass () {
      switch (this.level) {
        case 0:
          return 'text-xl'
        case 1:
          return 'text-lg'
        case 2:
          return 'text-base'
        case 3:
          return 'text-sm'
      }
    },
    getNameClass () {
      switch (this.level) {
        case 0:
          return 'text-3xl font-black'
        case 1:
          return 'text-2xl'
        case 2:
          return 'text-xl'
        case 3:
          return 'text-lg'
      }
    },
    setAsSelectedGoal () {
      this.$store.dispatch('goals/setSelectedGoalId', this.goal.id)
    },
    async deleteGoal () {
      await this.$store.dispatch('goals/deleteGoal', this.goal)
      if (this.goal.parent) {
        this.deleted = true
      } else {
        this.$router.replace({ name: 'goals' })
      }
    }
  }
}
</script>
